import { isObjectElement, toValue } from '@swagger-api/apidom-core';
const ModelPropertyMacroVisitor = _ref => {
  let {
    modelPropertyMacro
  } = _ref;
  return {
    SchemaElement: {
      leave(schemaElement) {
        if (typeof schemaElement.properties === 'undefined') return;
        if (!isObjectElement(schemaElement.properties)) return;
        schemaElement.properties.forEach(property => {
          if (!isObjectElement(property)) return;
          property.set('default', modelPropertyMacro(toValue(property)));
        });
      }
    }
  };
};
export default ModelPropertyMacroVisitor;