"use strict";

exports.__esModule = true;
exports.default = void 0;
var _apidomCore = require("@swagger-api/apidom-core");
const ParameterMacroVisitor = ({
  parameterMacro
}) => {
  let macroOperation = null;
  return {
    OperationElement: {
      enter(operationElement) {
        macroOperation = operationElement;
      },
      leave() {
        macroOperation = null;
      }
    },
    ParameterElement: {
      leave(parameterElement) {
        const pojoOperation = macroOperation === null ? null : (0, _apidomCore.toValue)(macroOperation);
        const pojoParameter = (0, _apidomCore.toValue)(parameterElement);
        const defaultValue = parameterMacro(pojoOperation, pojoParameter);
        parameterElement.set('default', defaultValue);
      }
    }
  };
};
var _default = ParameterMacroVisitor;
exports.default = _default;