"use strict";

exports.__esModule = true;
exports.default = void 0;
var _apidomCore = require("@swagger-api/apidom-core");
const ModelPropertyMacroVisitor = ({
  modelPropertyMacro
}) => ({
  SchemaElement: {
    leave(schemaElement) {
      if (typeof schemaElement.properties === 'undefined') return;
      if (!(0, _apidomCore.isObjectElement)(schemaElement.properties)) return;
      schemaElement.properties.forEach(property => {
        if (!(0, _apidomCore.isObjectElement)(property)) return;
        property.set('default', modelPropertyMacro((0, _apidomCore.toValue)(property)));
      });
    }
  }
});
var _default = ModelPropertyMacroVisitor;
exports.default = _default;