"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _shortUniqueId = _interopRequireDefault(require("short-unique-id"));
var _minim = require("minim");
// @ts-ignore

/**
 * Plugin for decorating every element in ApiDOM tree with UUID.
 */

const plugin = ({
  length = 6
} = {}) => () => {
  let uuid;
  return {
    pre() {
      uuid = new _shortUniqueId.default({
        length
      });
    },
    visitor: {
      enter(element) {
        // eslint-disable-next-line no-param-reassign
        element.id = new _minim.StringElement(uuid());
      }
    },
    post() {
      uuid = null;
    }
  };
};
var _default = plugin;
exports.default = _default;