// @ts-ignore
import ShortUniqueId from 'short-unique-id';
import { StringElement } from 'minim';

/**
 * Plugin for decorating every element in ApiDOM tree with UUID.
 */

const plugin = ({
  length = 6
} = {}) => () => {
  let uuid;
  return {
    pre() {
      uuid = new ShortUniqueId({
        length
      });
    },
    visitor: {
      enter(element) {
        // eslint-disable-next-line no-param-reassign
        element.id = new StringElement(uuid());
      }
    },
    post() {
      uuid = null;
    }
  };
};
export default plugin;