import { curry, pathOr } from 'ramda';
import { PredicateVisitor, BREAK, visit } from "./visitor.js"; // find first element that satisfies the provided predicate
// find :: Pred -> Element -> Element | Undefined
const find = curry((predicate, element) => {
  const visitor = PredicateVisitor({
    predicate,
    returnOnTrue: BREAK
  });

  // @ts-ignore
  visit(element, visitor);
  return pathOr(undefined, [0], visitor.result);
});
export default find;