import stampit from 'stampit';
import { ObjectElement } from '@swagger-api/apidom-core';
import MapVisitor from "../generics/MapVisitor.js";
import FallbackVisitor from "../FallbackVisitor.js";
import ParentSchemaAwareVisitor from "./ParentSchemaAwareVisitor.js";
import { isJSONReferenceLikeElement } from "../../predicates.js";
const DependenciesVisitor = stampit(MapVisitor, ParentSchemaAwareVisitor, FallbackVisitor, {
  props: {
    specPath: element => isJSONReferenceLikeElement(element) ? ['document', 'objects', 'JSONReference'] : ['document', 'objects', 'JSONSchema']
  },
  init() {
    this.element = new ObjectElement();
    this.element.classes.push('json-schema-dependencies');
  }
});
export default DependenciesVisitor;