import stampit from 'stampit';
import { ArrayElement, BREAK } from '@swagger-api/apidom-core';
import FallbackVisitor from "../FallbackVisitor.js";
import SpecificationVisitor from "../SpecificationVisitor.js";
import ParentSchemaAwareVisitor from "./ParentSchemaAwareVisitor.js";
const LinksVisitor = stampit(SpecificationVisitor, ParentSchemaAwareVisitor, FallbackVisitor, {
  init() {
    this.element = new ArrayElement();
    this.element.classes.push('json-schema-links');
  },
  methods: {
    ArrayElement(arrayElement) {
      arrayElement.forEach(item => {
        const linkDescriptionElement = this.toRefractedElement(['document', 'objects', 'LinkDescription'], item);
        this.element.push(linkDescriptionElement);
      });
      this.copyMetaAndAttributes(arrayElement, this.element);
      return BREAK;
    }
  }
});
export default LinksVisitor;