"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _stampit = _interopRequireDefault(require("stampit"));
var _ramda = require("ramda");
var _apidomParserAdapterApiDesignSystemsJson = require("@swagger-api/apidom-parser-adapter-api-design-systems-json");
var _index = require("../../../util/errors/index.cjs");
var _Parser = _interopRequireDefault(require("../Parser.cjs"));
const ApiDesignSystemsJsonParser = (0, _stampit.default)(_Parser.default, {
  props: {
    name: 'api-design-systems-json',
    fileExtensions: ['.json'],
    mediaTypes: _apidomParserAdapterApiDesignSystemsJson.mediaTypes
  },
  methods: {
    async canParse(file) {
      const hasSupportedFileExtension = this.fileExtensions.length === 0 ? true : this.fileExtensions.includes(file.extension);
      const hasSupportedMediaType = this.mediaTypes.includes(file.mediaType);
      if (!hasSupportedFileExtension) return false;
      if (hasSupportedMediaType) return true;
      if (!hasSupportedMediaType) {
        return (0, _apidomParserAdapterApiDesignSystemsJson.detect)(file.toString());
      }
      return false;
    },
    async parse(file) {
      const source = file.toString();
      try {
        const parserOpts = (0, _ramda.pick)(['sourceMap', 'syntacticAnalysis', 'refractorOpts'], this);
        return await (0, _apidomParserAdapterApiDesignSystemsJson.parse)(source, parserOpts);
      } catch (error) {
        throw new _index.ParserError(`Error parsing "${file.uri}"`, error);
      }
    }
  }
});
var _default = ApiDesignSystemsJsonParser;
exports.default = _default;